Lattice Grid Buy a licence

demo D154

Cards, lists and feeds

Draw each row as a card instead of dividing it into columns

rowTemplate

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // rowTemplate draws each row as a small piece of layout instead of dividing it
  // into columns. The columns stay declared, because they remain the data model
  // behind sort, filter and the tool panel.
  const rowTemplate =
    '<div style="padding:11px 16px;line-height:1.35">' +
    '<div style="font-weight:600">{{data.service}} ' +
    '<span style="opacity:.55;font-weight:400">{{data.team}}</span></div>' +
    '<div style="opacity:.6;font-size:.85em;margin-top:2px">' +
    '{{data.region}} &middot; {{data.tier}} &middot; {{data.instances}} instances &middot; {{data.owner}}' +
    '</div></div>';

  const columns = [
    { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
    { field: 'team', title: 'Team', filter: { type: 'set' } },
    { field: 'owner', title: 'Owner', filter: { type: 'set' } },
    { field: 'tier', title: 'Tier', cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
    { field: 'state', title: 'State', cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'instances', title: 'Instances', type: 'number' },
    { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' }, total: 'sum' },
  ];

  const rows = [/* wide service records */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        rowHeight={82}
        rowTemplate={rowTemplate}
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Drawing rows as cards instead of columns

A card layout renders each row as a single card or feed item rather than dividing it into aligned columns. A developer reaches for this when the data reads better as a stack of records than as a table: a feed of activity, a set of profile cards, a list of messages, a mobile view where columns would be too narrow to be useful. Lattice Grid takes a rowTemplate that receives the row and returns the markup for one card, so the visible layout is yours to design while the columns stay the data model underneath: sorting, filtering, grouping and export all continue to work against the columns, even though nothing is drawn in a grid of cells. As a JavaScript data grid, the card body is still virtualised, so a feed of many thousands of cards renders only those in view and recycles card elements as the user scrolls, keeping memory flat regardless of list length. Because the columns remain the model, each card exposes its underlying fields to assistive technology, and the card container is announced as a list item rather than a table cell, matching how the content actually reads.

How do I show data grid rows as cards instead of a table?

Provide a rowTemplate that takes a row and returns the markup for one card. Lattice Grid draws each row with your template instead of splitting it into columns, while the columns remain the data model, so sorting, filtering, grouping and export keep working. The card body stays virtualised, rendering only the cards currently in view.

Lattice Grid Buy a licence

demo D154

Cards, lists and feeds

Draw each row as a card instead of dividing it into columns

rowTemplate

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// rowTemplate draws each row as a small piece of layout instead of dividing it
// into columns. The columns stay declared, because they remain the data model
// behind sort, filter and the tool panel.
const rowTemplate =
  '<div style="padding:11px 16px;line-height:1.35">' +
  '<div style="font-weight:600">{{data.service}} ' +
  '<span style="opacity:.55;font-weight:400">{{data.team}}</span></div>' +
  '<div style="opacity:.6;font-size:.85em;margin-top:2px">' +
  '{{data.region}} &middot; {{data.tier}} &middot; {{data.instances}} instances &middot; {{data.owner}}' +
  '</div></div>';

const columns = [
  { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
  { field: 'team', title: 'Team', filter: { type: 'set' } },
  { field: 'owner', title: 'Owner', filter: { type: 'set' } },
  { field: 'tier', title: 'Tier', cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
  { field: 'state', title: 'State', cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'instances', title: 'Instances', type: 'number' },
  { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' }, total: 'sum' },
];

const rows = [/* wide service records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    rowHeight: 82,
    rowTemplate: rowTemplate,
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Drawing rows as cards instead of columns

A card layout renders each row as a single card or feed item rather than dividing it into aligned columns. A developer reaches for this when the data reads better as a stack of records than as a table: a feed of activity, a set of profile cards, a list of messages, a mobile view where columns would be too narrow to be useful. Lattice Grid takes a rowTemplate that receives the row and returns the markup for one card, so the visible layout is yours to design while the columns stay the data model underneath: sorting, filtering, grouping and export all continue to work against the columns, even though nothing is drawn in a grid of cells. As a JavaScript data grid, the card body is still virtualised, so a feed of many thousands of cards renders only those in view and recycles card elements as the user scrolls, keeping memory flat regardless of list length. Because the columns remain the model, each card exposes its underlying fields to assistive technology, and the card container is announced as a list item rather than a table cell, matching how the content actually reads.

How do I show data grid rows as cards instead of a table?

Provide a rowTemplate that takes a row and returns the markup for one card. Lattice Grid draws each row with your template instead of splitting it into columns, while the columns remain the data model, so sorting, filtering, grouping and export keep working. The card body stays virtualised, rendering only the cards currently in view.